﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace KeepCellStyleOutOfVisibleAreaSample
{
    public class FieldRecordToCellConverter : IMultiValueConverter
    {
        #region IMultiValueConverter Members

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values.Length != 2)
                return Binding.DoNothing;

            Field fld = values[0] as Field;
            DataRecord rcd = values[1] as DataRecord;

            if (null == fld || null == rcd)
                return Binding.DoNothing;

            return rcd.Cells[fld];
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            Cell cell = value as Cell;

            if (null == cell)
                return null;

            return new object[] { cell.Field, cell.Record };
        }

        #endregion
    }
    
    public  class CvpBackgroundBrushConverter:IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is bool && (bool)value)
            {
                return true;
            }
            else
            {
                return false; 
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
