﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;

namespace KeepCellStyleOutOfVisibleAreaSample
{
  
    public partial class KeepChangedCellStyle : Window
    {
        BindingList<Person> listOfPeople;
        public KeepChangedCellStyle()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            InitializeListOfPeople();
            xamDataGrid1.DataSource = listOfPeople;
            xamDataGrid1.CellUpdated += new EventHandler<Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs>(xamDataGrid1_CellUpdated);
        }

        private void InitializeListOfPeople()
        {
            listOfPeople = new BindingList<Person>();
            listOfPeople.AllowEdit = true;
            for (int i = 0; i < 120; i++)
            {
                Person person = new Person();
                person.ID = i;
                person.FirstName = "Ivan";
                person.LastName = "Ivanov";
                listOfPeople.Add(person);
            }
        }

        private void xamDataGrid1_CellUpdated(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatedEventArgs e)
        {
            e.Cell.Tag = true; 
        }
    }


    public class Person :INotifyPropertyChanged
    {
        private string fname;
        public string FirstName
        {
            get { return fname; }
            set
            {
                fname = value;
                OnPropertyChanged("FirstName");
            }
        }

        private string lname;
        public string LastName
        {
            get { return lname; }
            set
            {
                lname = value;
                OnPropertyChanged("LastName");
            }
        }

        private int id;
        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                OnPropertyChanged("ID");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }

        #endregion
    }
}
